#define CRYPT_KEY	"Test Key That is VERY very long!"


function Main()
	LOCAL cEncrypted

	CLS

	// encrypt a string with one simple call...
	cEncrypted := Crypt( "This is an encrypted string...", "TestKey" )

	// decrypt it with the same exact call...
	? Crypt( cEncrypted, "TestKey" )

	// use any length of key, the longer the better
	cEncrypted := Crypt( "This is an encrypted string...", CRYPT_KEY )

	// and if it doesn't match the original key, it's still encrypted!
	? Crypt( cEncrypted, "NotTheKey" )

	// Even more secure encryption...
	? MoreSecure( space(40), "This is an encryption key." )
	? MoreSecure( MoreSecure( "This is an encrypted string...", CRYPT_KEY ), ;
																																CRYPT_KEY )

	// and finally, encrypt a file...
	? "Encrypting File: CRYPTER.PRG "
	memowrit( "CRYPTER.GRP", Crypt( memoread( "CRYPTER.PRG" ), CRYPT_KEY ) )

return NIL


// Sample function to make crypt more secure
function MoreSecure( cText, cKey )
	local cCrypt, cNewKey

	cNewKey := Crypt( cKey, "Second key to make it more secure." )

	cCrypt := Crypt( cText, cNewKey )

return cCrypt

