*****************************************************************************
******************************************************************************
*
*	SilverWare Inc. Copyright (C) 1987 
*
*    	Author:		John P. Halovanic
*
*	Date:		9-15-86
*
*	Program Name:	Silver Talk 1.10
*
*	File Name:	swtalk.prg
*
*	Side Effects:	(none)
*
*
*	Silver Talk is a demonstration of how to use the SilverComm
*	communications library.  Registered users feel free to change,
*	copy or use any or all source code for your own development.
* 
******************************************************************************
******************************************************************************
save screen to opensc
set talk off
set scoreboard off
set safety off
set confirm off
set escape off
set echo off
set escape off
set bell off
do  pubvar
do  initvar
clear
set color to &blink
?chr(7)
@20,33 say [INITIALIZING]
do  setup
clear
if  ! (file([swtalk.dbf]))
    do boxer with 10,25,14,55,[ ],blue
    set color to &yellow
    @12,30 say [Creating SWTALK.DBF]
    set color to &yellow
    do  nofile
endif
if  (!devicepres(1) .and. !devicepres(2))
    tmpvar = [?]	
    set color to &blink	
    @2,2 say [You Must Have Communications Ports Available To Continue] get tmpvar
    read
    return
endif
*************************************************
*	Set the F1 key to the procedure help.   *
*************************************************
set key 28 to help
**********************************
*	Main body of program.	 *
**********************************
do while .t.
   help_code = [01]
   store 1 to m_choice
   set message to 22   
   set color to &yellow
   clear
   do  screen6 with [ SILVER TALK ],blue,cyan
   m_choice = 1
   set color to &yellow
   @ 06,22 prompt [PRODUCT Information ] message [ View product information.]
   @ 08,25 prompt [DIALING Directory   ] message [ Enter dialing directory.]
   @ 10,28 prompt [TERMINAL Mode       ] message [ Enter TERMINAL mode.]
   @ 12,31 prompt [XMODEM UP/DOWN Load ] message [ Up/down load files via XMODEM.]
   @ 14,34 prompt [SYSTEM Configuration] message [ Set system default configurations.]
   @ 16,37 prompt [EXIT Program        ] message [ Close all files and terminate your session with The Silver Talk Program.]
   menu to m_choice   
      do case          
         case m_choice = 1
	    do  product
	 case m_choice = 2
      	    do  dial
         case m_choice = 3
	    save screen to schold
	    do boxer with 10,05,14,74,[ ],blue
	    set color to &yellow
	    x_choice = 2
	    @012,08 prompt [Dumb TTY] message [ Go to terminal mode.]
	    @012,18 prompt [Smart TERMINAL] message [ Go to terminal mode with TTY Clipper terminal emulation.]
	    @012,35 prompt [Mode ANSI Terminal] message [ Go to terminal mode using ANSI terminal emulation function.]
	    @012,55 prompt [TTY] message [ Go to terminal mode using TTY terminal emulation function.]
	    @012,59 prompt [AUTO/Answer] message [ Enable auto/answer mode.]
	    menu to x_choice
	    trm = []
	    do  case
	    	case x_choice = 1
		    ext = [ ]
		    clk = [ ] 
		    trm = [D]
		    auto = .F.
		case x_choice = 2
		    ext = [Exit: ESC]
	  	    clk = [   MAIL: ^T  ]
		    trm = [S]
		    auto = .F.
		case x_choice = 3
		    ext = [ ]
		    clk = [ ] 
		    trm = [A]
		    auto = .F.   
	    	case x_choice = 4
		    ext = [Exit: Alt-F10]
	  	    clk = [         ]
		    trm = [T]
		    auto = .F.   
	    	case x_choice = 5
		    restore screen from schold
		    do boxer with 10,09,14,71,[ ],blue
		    set color to &yellow
		    menu_4 = 2
		    @12,12 say [Enter Terminal:       Use Up/Down arrows  ]+chr(24)+chr(25)
		    @12,28 prompt [Dumb ]  message [ Go to terminal mode auto answer.]
		    @12,28 prompt [Smart] message [ Go to terminal mode with TTY Clipper terminal emulation auto answer.]
		    @12,28 prompt [TTY  ] message [ Go to terminal mode using TTY terminal emulation function auto answer.]
		    @12,28 prompt [ANSI ] message [ Go to terminal mode using ANSI terminal emulation function auto answer.]
		    menu to menu_3
		    do  case
		        case menu_3 = 1
		            trm = [D]
			    ext = [ ]
			    clk = [ ] 
			case menu_3 = 2
		            trm = [S]
			    ext = [Exit: ESC]
			    clk = [   MAIL: ^T  ]
			case menu_3 = 3
		            trm = [T]
			    ext = [Exit: Alt-F10]
			    clk = [         ]
			case menu_3 = 4
			    ext = [ ]
			    clk = [ ] 
		            trm = [A]
		    endcase
		    ddial = [Waiting...]
		    smescape(port)
		    smautoansw(port,[1])
		    auto = .T.
	    endcase
	    if  pparity = 0
	    	hparity = [NONE]
	    else
	    	if  pparity = 1
		    hparity = [ODD]
		else
		    if  pparity = 2
		    	hparity = [EVEN]
		    endif
		endif
	    endif
	    head = [ Baud:]+str(baud,5,0)+[  ]+[Parity: ]+hparity+[  ]+[Stop Bits: ]+str(pstop,1,0)+[  ]+[Word Length: ]+str(pword,1,0)+[  ]+ext+[ ]+clk
	    setbaud(port,baud,pparity,pstop,pword)	    
	    rxflush(port)
	    emtype = trm
	    release schold
	    do  term
         case m_choice = 4
	    do boxer with 10,20,14,60,[ ],blue
	    set color to &yellow
	    x_choice = 1
	    @012,24 prompt [SEND XMODEM   ] message [UP Load file via XMODEM.]
	    @012,42 prompt [RECEIVE XMODEM] message [DOWN Load file via XMODEM.]
	    menu to x_choice
	    do  case
	    	case x_choice = 1
		    do  upload
	    	case x_choice = 2
		    do  download
	    endcase
         case m_choice = 5
	    do  sysconf
         case m_choice = 6
	    txstring(port,[ATZ])
	    txchar(port,chr(13))
            closecomm(1)
            closecomm(2)
	    set color to &white
	    exit
      endcase
enddo  
restore screen from opensc
release all
clear memory
quit


*********** PROCEDURES ************

*************************************************************
*	This is an example of a ANSI terminal emulation.    *
*************************************************************
PROCEDURE aterm
clear
?[You must have ANSI.SYS installed in CONFIG.SYS for emulation.]
?[Emample: DEVICE = <PATH>\ANSI.SYS]
?
?[You Are In ANSI Terminal Emulation, Press Shift ~ to EXIT...]
?
?ddial
ddial = []
**********************************************************************
*   Exit Key is 126  ( Shift ~)
**********************************************************************
SWEMANSI(port,126)
return


**********************************************************************
*	This procedure uses the box command to draw message boxes.   *
**********************************************************************
PROCEDURE boxer
PARAMETERS tl,tr,bl,br,fr,co
*** (ie.)  do  boxer with <expN>,<expN>,<expN>,<expN>,<expC>,<expC> ***
set color to &co
@ tl,tr,bl,br BOX fr
return

*************************************************************
*	This is the 1st of two main system color routines.  *
*	This procedure will enable you to set screen and    *
*       text system color defaults.			    *
*************************************************************
PROCEDURE  chgcol1
do colset
public tblue,tyellow,tyellowt,bk
bk = blue
tblue = blue
tyellow = yellow
set message to 22
do colbox
do colbar with 13,23
do colbar with 43,53
set color to &cyan
@5,13 say [ SCREEN ]
@5,43 say [ TEXT ]
set color to &yellow
choice = 1
@2,2 prompt [Change System COLORS] message [ Change system colors.]
@2,24 prompt [NEXT Menu]            message [ Goto color two menu.]
menu to choice
if choice = 2
   return
endif
screen = 1
* SCREEN
do colprmt with 13,[screen]
do  case
    case screen = 1
         tblue = [b+/n, w+/b,n]
    case screen = 2
         tblue = [bg+/n,w+/b,n]
    case screen = 3
         tblue = [g+/n, w+/b,n]
    case screen = 4
         tblue = [rg+/n,w+/b,n]
    case screen = 5
         tblue = [w+/n, w+/b,n]
    case screen = 6
         tblue = [r+/n, w+/b,n]
endcase
screen = 4
* TEXT
do colprmt with 43,[text]
do  case
    case screen = 1
         tyellow = [b+/n,w+/b,n]
	 tyellowt= [n/b,n/b,n]
	 attrib = 9
    case screen = 2
         tyellow = [bg+/n,w+/b,n]
	 tyellowt= [n/bg,n/bg,n]
	 attrib = 11
    case screen = 3
         tyellow = [g+/n, w+/b,n]
	 tyellowt= [n/g, n/g,n]
	 attrib = 10
    case screen = 4
         tyellow = [rg+/n,w+/b,n]
	 tyellowt= [n/rg,n/rg+,n]
	 attrib = 14
    case screen = 5
         tyellow = [w+/n, w+/b,n]
	 tyellowt= [n/w, n/w,n]
	 attrib = 15
    case screen = 6
         tyellow = [r+/n, w+/b,n]
	 tyellowt= [n/r, n/r,n]
	 attrib = 4
endcase
return


**************************************************************
*	This is the 2nd of two main system color routines.   *
*	This procedure will enable you to set menu names and *
*	system messages color defaults.			     *
**************************************************************
PROCEDURE  chgcol2
set color to &cyan
@5,13 say [ MENU NAMES ]
@5,43 say [ SYSTEM MESSAGES ]
set message to 22
do colbox
do colbar with 13,23
do colbar with 43,53
@5,13 say [ MENU NAMES ]
@5,43 say [ SYSTEM MESSAGES ]
set color to &yellow
choice = 1
@2,2 prompt [Change System COLORS] message [ Change system colors.]
@2,24 prompt [RETURN] message [ Return to test menu.]
menu to choice
if  choice = 2
    blue   = tblue
    yellow = tyellow
    yellowt= tyellowt
    return
endif
screen = 2
* menu
do colprmt with 13,[menu names]
do  case
    case screen = 1
         tcyan = [b+/n, w+/b,n]
    case screen = 2
         tcyan = [bg+/n,w+/b,n]
    case screen = 3
         tcyan = [g+/n, w+/b,n]
    case screen = 4
         tcyan = [rg+/n,w+/b,n]
    case screen = 5
         tcyan = [w+/n, w+/b,n]
    case screen = 6
         tcyan = [r+/n, w+/b,n]
endcase
screen = 6
* System
do colprmt with 43,[system]
do  case
    case screen = 1
         tred = [b+/n, w+/b,n]
	 tblink = [b+*/n, w+/b,n]
    case screen = 2
         tred = [bg+/n,w+/b,n]
	 tblink = [bg+*/n,w+/b,n]
    case screen = 3
         tred = [g+/n, w+/b,n]
	 tblink = [g+*/n, w+/b,n]
    case screen = 4
         tred = [rg+/n,w+/b,n]
	 tblink = [rg+*/n,w+/b,n]
    case screen = 5
         tred = [w+/n, w+/b,n]
	 tblink = [w+*/n, w+/b,n]
    case screen = 6
         tred = [r+/n, w+/b,n]
	 tblink = [r+*/n, w+/b,n]
endcase
blue   = tblue
yellow = tyellow
yellowt= tyellowt
red    = tred
blink  = tblink
cyan   = tcyan
release tblue,tyellow,tred,tblink,tcyan,tyellowt
return


*********************************************************************	
*	This is the system color defaults color option selector	    *
*	menu.							    *
*********************************************************************  
PROCEDURE colbar
PARAMETER ccol1,ccol2
set color to &blue
@7,ccol2 say replicate  ([],10)
set color to &cyan
@9,ccol2 say replicate  ([],10)
set color to &green
@11,ccol2 say replicate ([],10)
set color to &yellow
@13,ccol2 say replicate ([],10)
set color to &white
@15,ccol2 say replicate ([],10)
set color to &red
@17,ccol2 say replicate ([],10)
set color to &yellow
@7,ccol1  say [Blue  ] 
@9,ccol1  say [Cyan  ] 
@11,ccol1 say [Green ]
@13,ccol1 say [Yellow]
@15,ccol1 say [White ]
@17,ccol1 say [Red   ]
return


********************************************************************
*	This procedure draws a box for the color selection menu    *
********************************************************************
PROCEDURE colbox
clear
set color to &blue
@3,0,3,79 box doublebar
@21,0,21,79 box doublebar
@23,0,23,79 box doublebar
@5,10,19,35 box frame_1
@5,40,19,65 box frame_1
return


********************************************************************
*	This procedure use the prompt command to select a color    *
********************************************************************
PROCEDURE colprmt
PARAMETER ccol,ctxt
set color to &yellow
@7,ccol  prompt [Blue  ] message [ Set ]+ctxt+[ messages color to cyan.]
@9,ccol  prompt [Cyan  ] message [ Set ]+ctxt+[ messages color to cyan.]
@11,ccol prompt [Green ] message [ Set ]+ctxt+[ messages color to green.]
@13,ccol prompt [Yellow] message [ Set ]+ctxt+[ messages color to yellow.]
@15,ccol prompt [White ] message [ Set ]+ctxt+[ messages color to white.]
@17,ccol prompt [Red   ] message [ Set ]+ctxt+[ messages color to red.]
menu to screen
return


**************************************************************************
*	This procedure sets the initial default colors for the system.   *
************************************************************************** 
PROCEDURE colset
tblue    = [b/n,w+/n,n]
tyellow  = [rg+/n,w+/b,n]
tyellowt = [n/rg,n/rg+,n]
tred     = [r/n,w+/n,n]
tblink 	 = [r*/n,w+/n,n]
tcyan    = [bg/n,w+/n,n]
yellow   = [rg+/n,w+/b,n]
yellowt  = [n/rg,n/rg+,n]
cyan     = [bg/n,w+/n,n]
red      = [r/n,w+/n,n]
blue     = [b/n,w+/n,n]
white    = [w/n,n/w,n]
blink    = [r*/n,w+/n,n]
black    = [n/n,n/n,n]
green    = [g+/n, w+/b,n]
return


**************************************************************************
*	This procedure displays the first entry screen of Silver Talk    *
*	and also retrieves the SilverComm version and revision           *
**************************************************************************
PROCEDURE comp
set color to &blue
clear
set color to &cyan  
@03,01 say [                         S I L V E R    T A L K]
set color to &yellow
@05,01 say [                        Clipper Edition Ver. 1.10]
set color to &cyan
@07,01 say [                       Async. Communications Demo]
set color to &blink
@09,01 say [                               DISCLAIMER]
set color to &red
@11,01 say [    SilverWare Inc. MAKES NO WARRANTIES, express or implied concerning] 
@12,01 say [    this software including, BUT NOT LIMITED TO, implied warranties of]
@13,01 say [    MERCHANTABILITY and/or FITNESS for a particular purpose.  SilverWare]
@14,01 say [    Inc. Will NOT BE LIABLE for any damages, CONTINGENT or CONSEQUENTIAL,]
@15,01 say [    from the use of the product material presented by  SilverWare Inc..]
@16,01 say [    REGISTERED USERS OF SilverComm. Feel free to use ANY or ALL source]
@17,01 say [    code from this program for your own development purposes.  This] 
@18,01 say [    program is written in dBASE utilizing The SilverComm Library.]
set color to &cyan
@20,20 say [SilverComm Async Lib Version ]
set color to &yellow
@20,49 say setver()
tmpvar = [?]
set color to &yellow
@22,58 say [By ]
set color to &cyan
@22,61 say [John P. Halovanic]
help_code = [03]
@23,2 SAY [Press <ENTER> To Continue...] get tmpvar
read
return


**********************************************************************
*	This procedure controls all the options of the dial menu.    *
**********************************************************************
PROCEDURE dial
help_code = [01]
last = [ ]
a = 10
key = 0
declare a_mlinno[a],a_mname[a],a_mnum[a],a_mbaud[a],a_mpar[a],a_mstop[a],;
	a_mword[a],a_memul[a]
do  getarr
do  while .T.
    clear
    menu_1 = 3
    menu_2 = 1
    set color to &blue
    @01,03,20,78 box frame_1
    @22,00 say replicate([],79)
    @03,04 say replicate(doublebar,74)
    set color to &yellow
    @02,23 say [D I A L I N G    D I R E C T O R Y]
    @04,20 say [Name]+space(15)+[Number]+space(08)+[Baud      P    S    W]
    for i = 1 to a
        @i+4,7 say a_mlinno[i] pict[##]
	@i+4,9 say [- ]
	@i+4,11 say a_mname[i]
	@i+4,36 say a_mnum[i]
	@i+4,52 say a_mbaud[i] pict[#####]
	@i+4,63 say a_mpar[i]  pict[#]
	@i+4,68 say a_mstop[i] pict[#]
	@i+4,73 say a_mword[i] pict[#]
    next
    set message to 23
    set color to &cyan
    @18,34 say [Modem Dailing Command:]
    set color to &red
    @18,60 say [ATDT]
    set color to &yellow
    @16,10 prompt [CHANGE ENTRY  ] message [Revise dialing entry.]
    @16,34 prompt [MANUAL DIALING] message [User manual entry dialig.]
    @16,60 prompt [DIAL ENTRY    ] message [Dial predefined number.]
    @17,10 prompt [ERASE ENTRY   ] message [Delete predefined number.]
    @17,34 prompt [SELECT PORT] message [Set Comm. port to use (If available).]
    @17,60 prompt [AUTO REDIAL   ] message [Run Auto Redialer.]
    @18,10 prompt [QUIT DIALER   ] message [Exit dialing directory.]
    menu to menu_1  
    do  case
        case menu_1 = 1
	    set color to &yellow
    	    do  getent
	    if  menu_2 != 0
	    	help_code = [05]
	        do boxer with 10,09,14,71,[ ],blue
	        set color to &yellow
		@12,12 say [Enter Name: ] get a_mname[menu_2]
		read
		@12,12 say space(58)
		help_code = [06]
	        @12,12 say [Enter Number: ] get a_mnum[menu_2]
		read
		@12,12 say space(58)
		menu_3 = 4
		help_code = [01]
		@12,12 say [Select Baud Rate:            Use Up/Down arrows  ]+chr(24)+chr(25)
		@12,33 prompt [   50]
		@12,33 prompt [  110]
		@12,33 prompt [  300]
		@12,33 prompt [ 1200]
		@12,33 prompt [ 2400]
		@12,33 prompt [ 4800]
		@12,33 prompt [ 9600]
		@12,33 prompt [19200]
		menu to menu_3
		do  case
		    case menu_3 = 1
		    	a_mbaud[menu_2] = 50
		    case menu_3 = 2
		     	a_mbaud[menu_2] = 110
		    case menu_3 = 3
		    	a_mbaud[menu_2] = 300
		    case menu_3 = 4
		    	a_mbaud[menu_2] = 1200
		    case menu_3 = 5
		    	a_mbaud[menu_2] = 2400
		    case menu_3 = 6
		   	a_mbaud[menu_2] = 4800
		    case menu_3 = 7	 
		    	a_mbaud[menu_2] = 9600
		    case menu_3 = 8
		    	a_mbaud[menu_2] = 19200		
		endcase
		@12,12 say space(58)
		menu_3 = 3
		@12,12 say [Select Parity:          Use Up/Down arrows  ]+chr(24)+chr(25)		
		@12,28 prompt [ODD ]
		@12,28 prompt [EVEN]
		@12,28 prompt [NONE]
		menu to menu_3
		do  case
		    case menu_3 = 1
		        a_mpar[menu_2] = 1
		    case menu_3 = 2
		    	a_mpar[menu_2] = 2
		    case menu_3 = 3
		    	a_mpar[menu_2] = 0
		endcase    
		@12,12 say space(58)
		menu_3 = 1
		@12,12 say [Enter Stopbits:    Use Up/Down arrows  ]+chr(24)+chr(25)
		@12,28 prompt [1]
		@12,28 prompt [2]
		menu to menu_3
		do  case
		    case menu_3 = 1
		        a_mstop[menu_2] = 1
		    case menu_3 = 2
		    	a_mstop[menu_2] = 2
		endcase
		@12,12 say space(58)
		menu_3 = 2
		@12,12 say [Enter Word Length:    Use Up/Down arrows  ]+chr(24)+chr(25)
		@12,31 prompt [7]
		@12,31 prompt [8]
		menu to menu_3
		@12,12 say space(58)
		do  case
		    case menu_3 = 1
		        a_mword[menu_2] = 7
		    case menu_3 = 2
		    	a_mword[menu_2] = 8
		endcase
		menu_4 = 2
		@12,12 say [Enter Terminal:       Use Up/Down arrows  ]+chr(24)+chr(25)
		@12,28 prompt [Dumb ]
		@12,28 prompt [Smart]
		@12,28 prompt [TTY  ]
		@12,28 prompt [ANSI ]
		menu to menu_3
		do  case
		    case menu_3 = 1
		        a_memul[menu_2] = [D]
		    case menu_3 = 2
		        a_memul[menu_2] = [S]
		    case menu_3 = 3
		        a_memul[menu_2] = [T]
		    case menu_3 = 4
		        a_memul[menu_2] = [A]
		endcase
		@12,12 say space(58)
		tmpvar = [Y]
		help_code = [02]
		@12,12 say [Save Changes To Disk (Y/N) ] get tmpvar pict[!] valid(tmpvar$[YN])
		read
		if  tmpvar = [Y]
		    use swtalk
		    goto menu_2
		    repl name   with a_mname[menu_2]
		    repl num    with a_mnum[menu_2]
		    repl baud   with a_mbaud[menu_2]
		    repl parity with a_mpar[menu_2]
		    repl stop   with a_mstop[menu_2]
		    repl word   with a_mword[menu_2]    
		    repl emul   with a_memul[menu_2]    
		    close databases
		endif
	    endif
	case menu_1 = 2
	    do boxer with 10,09,14,71,[ ],blue
	    mannum = space(14)
	    set color to &yellow
	    @12,12 say [Please Enter Number to Dial: ] get mannum 
	    read
	    clear
	    setbaud(port,baud,pparity,pstop,pword)
	    last = mannum
            ddial = [Dialing ]+mannum
   	    smdial(port,trim(mannum))
	    rxflush(port)
	    do  term
	case menu_1 = 3
  	    do  getent
	    clear
	    if  menu_2 != 0
	    emtype = a_memul[menu_2]
	    if  a_mpar[menu_2] = 0
	    	hparity = [NONE]
	    else
	    	if  a_mpar[menu_2] = 1
		    hparity = [ODD]
		else
		    if  a_mpar[menu_2] = 2
		    	hparity = [EVEN]
		    endif
		endif
	    endif
	    do  case
	    	case emtype = [D]
		    ext = [ ]
		    clk = [ ] 
		    auto = .F.
		case emtype = [S]
		    ext = [Exit: ESC]
	  	    clk = [   MAIL: ^T  ]
		    auto = .F.
		case emtype = [A]
		    ext = [ ]
		    clk = [ ] 
		    auto = .F.   
	    	case emtype = [T]
		    ext = [Exit: Alt-F10]
	  	    clk = [         ]
		    auto = .F.   
	    endcase
	    head = [ Baud:]+str(a_mbaud[menu_2],5,0)+[  ]+[Parity: ]+hparity+[  ]+[Stop Bits: ]+str(a_mstop[menu_2],1,0)+[  ]+[Word Length: ]+str(a_mword[menu_2],1,0)+[  ]+ext+[ ]+clk
	        setbaud(port,a_mbaud[menu_2],a_mpar[menu_2],a_mstop[menu_2],a_mword[menu_2])
		
		ddial = [Dialing ]+trim(a_mname[menu_2])+[ ]
		smdial(port,trim(a_mnum[menu_2]))
		last = a_mnum[menu_2]
		rxflush(port)
		do  term
	    endif
    case menu_1 = 4
        do  getent
        do boxer with 09,05,15,77,[ ],blue
        set color to &yellow
	@11,7 say menu_2 pict[##]
	@11,9 say [- ]
	@11,11 say a_mname[menu_2]
	@11,36 say a_mnum[menu_2]
	@11,52 say a_mbaud[menu_2] pict[#####]
	@11,63 say a_mpar[menu_2]  pict[#]
	@11,68 say a_mstop[menu_2] pict[#]
	@11,73 say a_mword[menu_2] pict[#]
	tmpvar = [N]
	set color to &red
	help_code = [02]
	@13,20 say [Delete This Entry (Y/N) ] get tmpvar pict[!] valid(tmpvar$[YN])
	read
	if  tmpvar = [Y]
	    tmpvar = [N]	
	    @13,20 say space(30)
	    set color to &blink
	    @13,25 say [Are You Sure (Y/N) ] get tmpvar pict[!] valid(tmpvar$[YN])
	    read
	    if  tmpvar = [Y]
    	        do boxer with 09,05,15,77,[ ],blue
		set color to &blink
  	        @12,25 say [Processing Entry...]
		use swtalk
		goto menu_2
		a_mname[menu_2] = replicate([.],24)
		a_mnum[menu_2]  = replicate([.],14)
		a_mbaud[menu_2] = 1200
		a_mpar[menu_2]  = 0
		a_mstop[menu_2] = 1
		a_mword[menu_2] = 8
		a_memul[menu_2] = [T]
		repl name   with replicate([.],24)
		repl num    with replicate([.],14)
		repl baud   with 1200
		repl parity with 0
		repl stop   with 1
		repl word   with 8
		repl emul   with [T]
		close databases
	    endif
	endif
    case menu_1 = 5
    	help_code = [01]
	menu_3 = 1
	do boxer with 10,09,14,71,[ ],blue
	set color to &yellow
	@12,12 say [Select Desired Comm. Port   :      Use Up/Down arrows  ]+chr(24)+chr(25)]
	@12,42 prompt [COM1]
	@12,42 prompt [COM2]
	menu to menu_3
	do  case
	    case menu_3 = 1
	        port = 1
		opencomm(port,2000,2000)
	    case menu_3 = 2
		port = 2
		opencomm(port,2000,2000)
	endcase
    case menu_1 = 6
    	if  last != [ ]
	    test = dialloop()
	    if  test = 1
	    	do  term
	    else
	        smswhook(port,[0])
	    endif
	else
	    do boxer with 10,05,14,76,[ ],blue
	    tmpvar = [?]
	    set color to &red
	    help_code = [03]
	    @12,17 say [No Previous Found, Press <ENTER> To Continue...] get tmpvar 
	    read
    endif
    case menu_1 = 7
	release a_mlinno[a],a_mname[a],a_mnum[a],a_mbaud[a],a_mpar[a],;
		a_mstop[a],a_mword[a],a_memul[a]
   	return
    endcase
enddo
return


*****************************************************************
*       This procedure shows how to receive a file via XMODEM.  *
*****************************************************************
PROCEDURE download 
setbaud(port,baud,pparity,pstop,pword) 
do boxer with 10,04,14,75,[ ],blue 
set color to &yellow 
filchk = [?]
mfile = [?]  
do while (mfile != space(40))
    help_code = [05]
    set color to &yellow	 
    mfile = space(40)
    tfile = space(40)
    @12,12 say [Enter Filename: ] get mfile 
    read
    tfile = mfile
    if  file(mfile)
        tmpvar = [?]
	@12,12 say space(58)
	set color to &red
	help_code = [02]
	@12,24 say [File Exist, Overwrite (Y/N)] get tmpvar pict[!] valid(tmpvar$[YN])
	read
	@12,24 say space(40)
	if  tmpvar = [Y]
	    tfile = mfile
	    mfile = space(40)
	else
	   mfile = [?]
	endif
    else
	mfile = space(40)
    endif
enddo
if  tfile != space(40)
    blocks = [ ]
    time = [     ]
    bytes = [ ]
    do  xmodbox	
    set color to &blink
    @03,44 say [     Receiving: ]
    set color to &blue
    @14,74 say []
    start = seconds()
    error = errorchk(rxxmodem(port,tfile))
    stop = seconds()
    time = stop - start
    time = timer(time)
    set color to &yellow
    if  error = [cSUCCESSFUL]
    	blocks = str(txxblocks(tfile),8,0)
	bytes = str(swfilesize(tfile),8,0)
        @05,60 say bytes
	@06,60 say blocks
    endif
    set color to &blink
    @08,60 say error
    set color to &yellow
    @03,44 say [      PROTOCOL: XMODEM]
    @09,44 say [   ACTUAL TIME: ]+time
    tmpvar = [?]
    set color to &red
    help_code = [03]
    @13,43 say [Press <ENTER> To Continue...] get tmpvar
    read
    do  term
endif
return


*************************************************************
*	This is an example of a simple terminal program.    *
*************************************************************
PROCEDURE dterm
set color to &yellow
key = 0
clear
?[Press ESC To Exit Terminal Program / Ctrl-P To Toggle Printer...] 
?
?ddial
ddial = []
prt = .f.
do  while (key != 27)
    key = INKEY()	
	 if  key = 16
             if  prt
	         set print off
             	 prt = .F.
	      else
	         set print on
	      	 prt = .T.
	      endif
	 endif 
    if  (key != 0)
    	TXCHAR(port,chr(key))
    endif
    if  ( ! RXEMPTY(port))
        ??chr(RXCHAR(port))
    endif
enddo
return


*************************************************************************
*	This procedure loads an array with telephone numbers and COMM	*
*	attributes from SWTALK.DBF					*
*************************************************************************
PROCEDURE getarr
use swtalk
size = 0
count to size
goto 1
for i = 1 to 10
    a_mlinno[i]	  = i
    a_mname[i]	  = name
    a_mnum[i]  	  = num
    a_mbaud[i]    = baud
    a_mpar[i]	  = parity
    a_mstop[i]	  = stop
    a_mword[i]    = word
    a_memul[i]    = emul
    skip
next
close databases
return


**********************************************************************
*	This procedure use the prompt command to choose an entry     *
*	form the dialing directory. (ie.) Change, erase, and dial.   *
********************************************************************** 
PROCEDURE getent
public menu_2
menu_2 = 1
for i = 1 to a
    @i+4,11 prompt a_mname[i]
next
menu to menu_2
return


****************************************************************************
*	This procedure contains all the HELP information for the program.  *
*	When you press F1, control is passed to this procedure.		   *
****************************************************************************
PROCEDURE help
* HELP
ro = 99
co = 99
ro = row()
co = col()
c = 1
* Help procedures
ask_1 = [?]
PARAMETERS call_prg, line_num, input_var
set message to
save screen to shold2
set key 28
do case
   case help_code = [01]
      @15,29 prompt [ Press Enter To Continue ]      
      do boxer with 08,21,15,60,[ ],blue
      set color to &cyan
      @ 08,24 say [ MENU HELP ]
      set color to &yellow  
      @ 10,24 say [Use the UP and DOWN Arrow keys to]  
      @ 11,24 say [highlight the function then press]  
      @ 12,24 say [(RET) or press the letter of the ]  
      @ 13,24 say [function to execute.             ]  
      menu to c
   case help_code = [02]
      do boxer with 03,23,07,78,[ ],blue
      @07,39 prompt [ Press Enter To Continue ]      
      tmpvar = [?]
      set color to &yellow
      @05,30 say [Choose (Y)es or (N)o To Answer Question]
      menu to c
   case help_code = [03]
      do boxer with 10,25,14,55,[ ],blue
      @14,28 prompt [ Press Enter To Continue ]      
      tmpvar = [?]
      set color to &yellow
      @12,32 say [No Help Available]
      menu to c
   case help_code = [04]
      do boxer with 3,45,7,75,[ ],blue
      @07,48 prompt [ Press Enter To Continue ]      
      tmpvar = [?]
      set color to &yellow
      @05,48 say [Enter DRIVE:\PATH\FILENAME]
      menu to c
   case help_code = [05]
      do boxer with 05,45,09,75,[ ],blue
      @09,48 prompt [ Press Enter To Continue ]      
      tmpvar = [?]
      set color to &yellow
      @07,48 say [Enter a 24 Character Name]
      menu to c   
   case help_code = [06]
      do boxer with 05,45,09,75,[ ],blue
      @09,48 prompt [ Press Enter To Continue ]      
      tmpvar = [?]
      set color to &yellow
      @07,49 say [Enter a 14 Character #]
      menu to c   
   case help_code = [07]
      do boxer with 12,00,23,79,[͸Գ ],blue
      set color to &cyan 
      @ 12,02 say [ EDIT HELP ]
      set color to &yellow  
      @ 13,01 say [  Up arrow or ^E . . Up one line     PgUp . . . . . . Next window up         ]  
      @ 14,01 say [  Dn arrow or ^C . . Dn one line     PgDn . . . . . . Next window dn         ]  
      @ 15,01 say [  Lf arrow or ^S . . Lf one char    ^PgUp . . . . . . Bgn of current window  ]  
      @ 16,01 say [  Rt arrow or ^D . . Rt one char    ^PgDn . . . . . . End of current window  ]  
      @ 17,01 say [ ^Lt arrow or ^A . . Lt one word            EDIT KEYS                        ]  
      @ 18,01 say [ ^Rt arrow or ^F . . Rt one word    ^W  . . . . . . . Save and exit          ]  
      @ 19,01 say [  HOME . . . . . . . Bgn of line    Esc . . . . . . . Abort no change        ]  
      @ 20,01 say [  END  . . . . . . . End of line    ^Y  . . . . . . . Delete current line    ]  
      @ 21,01 say [ ^HOME . . . . . . . Bgn of memo    ^T  . . . . . . . Delele word right      ]  
      @ 22,01 say [ ^END  . . . . . . . End of memo    ^B  . . . . . . . Reformat memo          ]  

      @23,25 prompt [ Press Enter To Continue ]
      menu to c
endcase
restore screen from shold2
release shold2
set key 28 to help
@ ro,co say []
return


****************************************************************************
*	This procedure assigns values to all initial variables in program  *
****************************************************************************
PROCEDURE initvar
baud = 1200
pparity = 0
pstop = 1
pword = 8
auto = .F.
attrib = 14
ddial = []
ext = [Exit: ESC]
clk = [   MAIL: ^T  ]
if  pparity = 0
    hparity = [NONE]
else
    if  pparity = 1
	hparity = [ODD ]
    else
	if  pparity = 2
	    hparity = [EVEN]
        endif
    endif
endif
emtype = [T]
clk = [   MAIL: ^T  ]
head = [ Baud:]+str(baud,5,0)+[  ]+[Parity: ]+hparity+[  ]+[Stop Bits: ]+str(pstop,1,0)+[  ]+[Word Length: ]+str(pword,1,0)+[  ]+[Exit: ESC]+[ ]+clk
name 	= space(40)
company = space(40)
address = space(40)
city 	= space(40)
state 	= space(2)
country = space(40)
zip 	= space(11)
phone 	= space(15)
qnty	= 1
exp 	= date()
edi	= space(20)
comment1 = space(50)
comment2 = space(50)
comment3 = space(50)
comment4 = space(50)
cnum 	= space(25)
ptype = [ ]
id = [    ]
setterm = [N]
frame_1 = chr(201) + chr(205) + chr(187) + chr(186) + ;  
          chr(188) + chr(205) + chr(200) + chr(186) + chr(32)
frame_2   = chr(218) + chr(196) + chr(191) + chr(179) + ;  
            chr(217) + chr(196) + chr(192) + chr(179) + chr(32)
frame_3   = chr(213) + chr(205) + chr(184) + chr(179) + ;
            chr(190) + chr(205) + chr(212) + chr(179) + chr(32)
doublebar = []
singlebar = []
bar       = [ ]
if  iscolor()
    setterm = [Y]
endif 	
do case
   case setterm = [Y]
      color_ = .T.  
      do  colset
   case setterm   = [N]
      color_ = .F.  
      white    = [w/n,n/w,n]  
      yellow   = [w/n,n/w,n]  
      yellowt  = [n/w,n/w,n]        
      cyan     = [w/n,n/w,n]  
      red      = [w/n,n/w,n]
      blue     = [w/n,n/w,n]
      blink    = [w*/n,n/w,n]
      black    = [n/n,n/n,n]
endcase
do  comp
return


*************************************************************************
*	This procedure will create SWTALK.DBF if it is not present in	*
*	the default directory. 						*
*************************************************************************
PROCEDURE nofile
create swtemp
append blank
replace field_name with [name]
replace field_type with [c]
replace field_len  with 24
replace field_dec  with 0
append blank
replace field_name with [num]
replace field_type with [c]
replace field_len  with 14
replace field_dec  with 0
append blank
replace field_name with [baud]
replace field_type with [n]
replace field_len  with 5
replace field_dec  with 0
append blank
replace field_name with [parity]
replace field_type with [n]
replace field_len  with 1
replace field_dec  with 0
append blank
replace field_name with [stop]
replace field_type with [n]
replace field_len  with 1
replace field_dec  with 0
append blank
replace field_name with [word]
replace field_type with [n]
replace field_len  with 1
replace field_dec  with 0
append blank
replace field_name with [emul]
replace field_type with [c]
replace field_len  with 1
replace field_dec  with 0
close databases
create swtalk from swtemp 
erase swtemp.dbf
use swtalk
append blank
goto 1
repl name   with [Silver Bullit BBS]
repl num    with [1(214)902-0069]
repl baud   with 1200
repl parity with 0
repl stop   with 1
repl word   with 8
repl emul   with [A]

for i = 2 to 10
    append blank
    goto i
    repl name   with replicate([.],24)
    repl num    with replicate([.],14)
    repl baud   with 1200
    repl parity with 0
    repl stop   with 1
    repl word   with 8
    repl emul   with [T]
next
close databases
return


********************************************************************
*	This procedure set up a customer order for SilverComm.	   *
********************************************************************
PROCEDURE order
help_code = [07]
price = 149.95
do  while .t.
clear
help_code = [07]
do boxer with 05,13,21,68,[ ],blue
set color to &yellow
@3,21 say  [SilverWare Inc. Custom Order Generator]
@6,15 say  [    Name: ] get name
@7,15 say  [ Company: ] get company
@8,15 say  [ Address: ] get address
@9,15 say  [    City: ] get city
@10,15 say  [   State: ] get state pict[!!]
@10,30 say [ Zipcode: ] get zip
@11,15 say [ Country: ] get country
@12,15 say [ Phone #: ] get phone
@13,15 say [Quantity: ] get qnty pict[####]
@13,32 say [Edition : ] get edi pict[!!!!!!!!!!!!!!!!!!!!]
read
help_code = [01]
menu_3 = 3
@15,15 say [Type of Payment               Use Up/Down arrows  ]+chr(24)+chr(25)		
@15,31 prompt [VISA       ] 
@15,31 prompt [MASTER CARD]
@15,31 prompt [MONEY ORDER]
@15,31 prompt [CHECK      ]
menu to menu_3
help_code = [07]
@15,15 say space(52)
do  case 
    expl = .F.	
    case menu_3 = 1
    	type = [VISA]
        @14,15 say [Card #:   ] get cnum
	@15,15 say [Exp. Date:] get exp
	read
	expl = .T.
    case menu_3 = 2
    	type = [MASTER CARD]
        @14,15 say [Card #:   ] get cnum
	@15,15 say [Exp. Date:] get exp
	read
	expl = .T.
    case menu_3 = 3
    	type = [MONEY ORDER]
        @14,15 say [Order #:  ] get cnum
	read
    case menu_3 = 4
    	type = [CHECK]
        @14,15 say [Check #:  ] get cnum
	read
endcase    
if  state = [TX]
    tax = .0725
else
    tax = 0
endif
if  qnty != 0
    ship = ((qnty - 1) * 3.00) + 5.00
else
    ship = 0.00
endif
tax = (tax * (qnty * 149.95))
@16,15 say [Sub Total:  ]+[$]+str(qnty*149.95,10,2)
@17,15 say [Tax:        ]+[$]+str(tax,10,2)
@18,15 say [Shipping:   ]+[$]+str(ship,10,2)
@19,15 say [Amount Due: ]+[$]+str((qnty * 149.95 + tax + ship),10,2)
tmpvar = [?]
set color to &red
help_code = [02]
@20,15 say [Enter Customer Comment (Y/N)] get tmpvar pict[!] valid(tmpvar$[YN])
read
if  tmpvar = [Y]
    help_code = [07]
    @20,15 say space(38)
    save screen to sc1
    do boxer with 13,16,20,73,[ ],red
    set color to &yellow
    @13,23  say [ Enter Comments ]
    @15,20  get comment1
    @16,20  get comment2
    @17,20  get comment3
    @18,20  get comment4
    read
    restore screen from sc1
endif
tmpvar = [?]
set color to &red
@20,15 say space(38)
help_code = [02]
@20,15 say [Is This All Correct (Y/N)] get tmpvar pict[!] valid(tmpvar$[YN])
read
if  tmpvar = [Y]
    @20,15 say space(30)
    exit
endif
enddo
set color to &yellow
tmpvar = [?]
@16,40 say [Send To Printer (Y/N)] get tmpvar pict[!] valid(tmpvar$[YN])
read
if  tmpvar = [Y]
    pchoice = 1
    @17,40 say [Device:      Use ]+chr(24)+chr(25)		
    @17,48 prompt [LPT1]
    @17,48 prompt [LPT2]
    menu to pchoice
    do  case
    	case pchoice = 1
	    set printer to LPT1
    	case pchoice = 2
	    set printer to LPT2
    endcase
    set color to &blink
    @19,40 say [Printing on LP...]
    do  prntord
endif
return


********************************************************************
*	This procedure prints a customer order to LPT1 or LPT2.    *
********************************************************************
PROCEDURE prntord
set cons off
set print on
?space(25)+[------------------------------]
?space(25)+[SilverComm Customer Order Form]
?space(25)+[------------------------------]
?
?
?
?
?
?
?space(10)+[SilverWare Inc.]
?space(10)+[P.O. Box 781143]
?space(10)+[Dallas, Texas  75378 U.S.A.]
?
?
?
?
?
?replicate([=],78)
?space(07)+[Send Product To: ]+trim(name)
?space(24)+trim(address)
?space(24)+trim(city)+[, ]+trim(state)+[  ]+trim(zip)+[  ]+trim(country)
?space(24)+[Phone #: ]+trim(phone)
?replicate([=],78)
?
?
?space(10)+[   Edition : ]+trim(edi)
?space(10)+[   Quantity: ]+str(qnty,11,0)  
?space(10)+[     Price : ]+[$]+str(price,10,2)
?space(10)+[  Sub Total: ]+[$]+str(qnty*149.95,10,2)
?space(10)+[        Tax: ]+[$]+str(tax,10,2)
?space(10)+[   Shipping: ]+[$]+str(ship,10,2)
?space(10)+[             ===========]
?space(10)+[      Total: ]+[$]+str((qnty * 149.95 + tax + ship),10,2)
?
?space(10)+[ Type of Payment: ]+type
?space(10)+[          Number: ]+cnum
if  expl
    ?space(10)+[       Exp. Date: ]+dtoc(exp)
    if ptype = [MASTER CARD]
       ?space(10)+[       Bank ID #: ]+id
    endif
endif
?
?
?replicate([=],55)
?space(5)+[CUSTOMER COMMENT:]
?space(5)+comment1
?space(5)+comment2
?space(5)+comment3
?space(5)+comment4
?replicate([=],55)
?
?
?
?
?replicate([=],78)
?space(5)+[Thank you for interest in the SilverComm Library.]
?space(5)+[If you have any further question, Please call: (214) 902-0227]
? replicate([=],78)
?
?
?space(45)+[Sign Here: ______________________]
eject
set print off
set cons on
return


**************************************************************************
*	This procedure displays customer information about SilverComm.   *
**************************************************************************
PROCEDURE product
help_code = [03]
set color to &yellow
clear
?[DALLAS, TEXAS - SilverWare Inc. demo system for SilverComm.  The]
?[affordable, comprehensive, interrupt driven, asynchronous communications]
?[library for dBASE III PLUS, Clipper, dBXL / QUICKSILVER and FoxBASE+.  With]
?[SilverComm, programmers finally hold the utensils to design robust interrupt]
?[driven communications applications with simultaneous buffered input/output]
?[to both COM1/COM2 at baud rates up to 19.2 Kbaud.]
?
?[SilverComm includes the following: An advanced communications function]
?[library that links directly with your compiled application. There are NO]
?[terminate and stay resident programs.  Silver Talk: A comprehensive terminal]
?[program with dialing directory, XMODEM download/upload capabilities that]
?[fully demonstrates the power of the SilverComm library (complete with well]
?[documented source code that can be used as is or modified for custom appli-]
?[cations).  Professionally documented, typeset manual with slipcase.]
?[Absolutely NO royalties, No copy protection and free technical support.]
?
?[SilverComm also includes XMODEM file transmit/receive functions, Hayes and]
?[Hayes compatible modem control functions, user specifiable transmit and]
?[receive buffer sizes, RTS/CTS (hardware) flow control, modem status and]
?[control functions, line status functions, delayed character fetch, queue]
?[status functions, line error detecting functions, an internal ring counter]
?[and comprehensive consistent error return codes.]
?
wait
clear
?[This library is extremely efficient, modular and compact.  Adding Interrupt]
?[driven communications capability can be accomplished in as little as 6K with]
?[Clipper and 53K with dBASE III PLUS, dBXL / Quicksilver or FoxBASE+.  Except]
?[ional performance is not limited to the high speed AT/386 systems, a 4.77]
?[MHZ IBM-PC can also transmit or receive at 19.2 Kbaud flawlessly.  Registered]
?[users of the SilverComm Library feel free to use any or all source code of the]
?[SilverTalk program for your own development. We hold NO royalities towards]
?[our registered users.] 
?
?[Future plans for SilverComm include supporting additional compilers,]
?[additional file transfer protocols and remote command processing.  Also a]
?[bulletin board system to be used as a technical support tool, a communica-]
?[tions test site and a SilverComm users forum. Coming soon, additional]
?[SilverWare programming utensils and THE SILVER BULLIT...]
?
?[SilverComm requires dBASE III PLUS, Clipper Autumn 86 or later, dBXL,] 
?[QUICKSILVER, FoxBASE+, IBM PC/XT/AT/Compaq 386 or compatible, PC/MS-DOS 2.1]
?[or later.]
?
?[Suggested retail price is $149.95.]
?
?[SilverComm is available from SilverWare Inc., P.O. Box 781143, Dallas,]
?[Texas, 75378, phone (214) 902-0227.]
wait
clear
do boxer with 10,04,14,75,[ ],blue
tmpvar = [Y]
set color to &red
help_code = [02]
@12,20 say [Would You Like To Order SilverComm (Y/N)] get tmpvar pict[!] valid(tmpvar$[YN])
read
if  tmpvar = [Y]
    do  order
endif

return


*************************************************************************
*	This procedure sets up all public variables for the program. 	*
*************************************************************************
PROCEDURE pubvar
public clipper, red, yellow, yellowt, cyan, green, blue, white, frame_1, frame_2, frame_3,attrib
public  doublebar,  help_code, singlebar, blink
public setterm, grey,ask_2,bar,syellow,sctest,filprs
public tblue,tyellow,tyellowt,tred,tblink,tcyan
public port,baud,pparity,pstop,pword,head,ddial,auto,chanset,ext,clk
public name,company,address,city,state,country,zip,phone,qnty,cnum,expl,edi
public comment1,comment2,comment3,comment4,exp,id,ptype
public emtype
return


*****************************************************************
*	This procedure displays the main SilverTalk menu.	*
*****************************************************************
PROCEDURE screen6
PARAMETER mn, cm, cn
*** (ie.)  do  screen6 with <expC>,<expC>,<expC> *** 
clear
set color to &cm
@21,0,21,79  box doublebar
@23,0,23,79  box doublebar
@3,0,3,79    box doublebar
@5,17,9,47   box frame_1
@7,20,11,50  box frame_1
@9,23,13,53  box frame_1
@11,26,15,56 box frame_1
@13,29,17,59 box frame_1
@15,32,19,62 box frame_1
set color to &cn
@3,3 say mn 
return


**********************************************************************
*	This procedure sets all initial communications defaults.     *
**********************************************************************	
PROCEDURE setup
port = 1
if  (opencomm(port,2000,2000)!=0)
    if  (opencomm(2,2000,2000)!=0)
    	set color to &yellow
	clear
	@2,2 say [No COMM ports detected by system]
        quit
    else
    	port = 2
    endif
endif
smreset(port)
smescape(port)
smsetreg(port,[11],[50])
rxflush(port)
setbaud(port,baud,pparity,pstop,pword)	
return


***************************************************************************
*	This procedure is an example of a TTY terminal emulation routine  *
***************************************************************************
PROCEDURE sterm
set color to &yellow
clear
@1,0 say ddial
ddial = []
set color to &yellowt
@0,0 say head
key = 0
rrow = 1
ccol = 0
setcurpos(rrow,ccol)	
chkmin = [00]
do  while(key != 27)
    key = inkey()
    if  (key!=0)
    	 if  key != 20
             txchar(port,chr(key))
	 endif
	 if  key = 20
	     save screen to msch
	     do boxer with 10,04,14,75,[ ],blue
	     set color to &cyan
	     @10,25 say [ This Is An ASCII File Upload ]
	     @14,15 say [ Recomended Use For Silver Bullet Electronic Mail ]

	     filchk = [?]
	     mfile = [?]
	     do  while (mfile != space(40))
	         help_code = [04]
		 set color to &yellow	 
		 mfile = space(40)
		 @12,12 say [Enter Filename: ] get mfile 
		 read
		 if  ! file(mfile)
	             if  mfile != space(40)
		     	 tmpvar = [?]
			 @12,12 say space(58)
			 set color to &red
			 @12,19 say [File Not Found press any key to continue: ] get tmpvar 
			 read
			 @12,19 say space(45)
		      endif
		  else
		      tfile = mfile
		      mfile = space(40)
		      m_mesmem = memoread(tfile)
		      m_mesmem = substr(m_mesmem,1,LEN(m_mesmem)-1)
		      txstring(port,m_mesmem)
		  endif
	     enddo
  	     setcurpos(rrow,ccol)
	     restore screen from msch
	 endif 
    endif
    input=rxchar(port)
    if  input < 0
    	loop
    endif
    if  input > 31
        swputchar(chr(input),attrib)
	ccol = ccol + 1
	if  ccol = 80
	    ccol = 0
	    if  rrow < 24
		rrow = rrow + 1
	    else
		scrollup(1,0,24,79,1,attrib)
	    endif		    
	 endif
         setcurpos(rrow,ccol)
     else
         do  case
	     case input = 9
	     	  ccol = ccol + 1
		  do  while (ccol%8) != 0
		      ccol = ccol + 1
		  enddo
		  setcurpos(rrow,ccol)
     	     case input = 13
	         ccol = 0
	         setcurpos(rrow,ccol)
	     case input = 10
	         rrow = rrow + 1
	         if  rrow > 24
	             rrow = 24
		     scrollup(1,0,24,79,1,attrib)
	         endif
	         setcurpos(rrow,ccol)
	     case input = 12
	         rrow = 1
	         ccol = 0
	        setcurpos(rrow,ccol)
	        scrollup(1,0,24,79,0,attrib)
	     case input = 7
	          @ rrow,ccol say []
	          ??chr(7)
    	     case input = 8
	         if  ccol != 0
 	             ccol = ccol - 1
		     setcurpos(rrow,ccol)
		 endif
             endcase
     endif
enddo
return


*************************************************
*	This is the system configuration menu.	*
*************************************************
PROCEDURE sysconf
do boxer with 10,20,14,60,[ ],blue
set color to &yellow
x_choice = 1
@012,24 prompt [SYSTEM Colors  ] message [ Change system colors.]
@012,42 prompt [MODEM Config.  ] message [ Change modem default configuration.]
menu to x_choice
do  case
    case x_choice = 1
    	if  iscolor()
  	    do  chgcol1	 
	    do  chgcol2	    
        else
	    set color to &red
	    tmpvar = [?]
	    @2,2 say [Color monitor not detected by system...] get tmpvar
	    read
	endif
    case x_choice = 2
    	do  sysdef
endcase
return


*************************************************************************
*	This procedure enables you to set all modem communications      *
*	default parameters for program.					*
*************************************************************************
PROCEDURE sysdef
do boxer with 10,09,14,71,[ ],blue
set color to &yellow
menu_3 = 4
@12,12 say space(58)
@12,12 say [Select Baud Rate:            Use Up/Down arrows  ]+chr(24)+chr(25)
@12,33 prompt [   50]
@12,33 prompt [  110]
@12,33 prompt [  300]
@12,33 prompt [ 1200]
@12,33 prompt [ 2400]
@12,33 prompt [ 4800]
@12,33 prompt [ 9600]
@12,33 prompt [19200]
menu to menu_3
do  case
    case menu_3 = 1
    	baud = 50
    case menu_3 = 2
     	baud = 110
    case menu_3 = 3
    	baud = 300
    case menu_3 = 4
    	baud = 1200
    case menu_3 = 5
    	baud = 2400
    case menu_3 = 6
   	baud = 4800
    case menu_3 = 7	 
    	baud = 9600
    case menu_3 = 8
    	baud = 19200		
endcase
@12,12 say space(58)
menu_3 = 3
@12,12 say [Select Parity:          Use Up/Down arrows  ]+chr(24)+chr(25)		
@12,28 prompt [ODD ]
@12,28 prompt [EVEN]
@12,28 prompt [NONE]
menu to menu_3
do  case
    case menu_3 = 1
        pparity = 1
    case menu_3 = 2
    	pparity = 2
    case menu_3 = 3
    	pparity = 0
endcase    
@12,12 say space(58)
menu_3 = 1
@12,12 say [Enter Stopbits:    Use Up/Down arrows  ]+chr(24)+chr(25)
@12,28 prompt [1]
@12,28 prompt [2]
menu to menu_3
do  case
    case menu_3 = 1
        pstop = 1
    case menu_3 = 2
    	pstop = 2
endcase
@12,12 say space(58)
menu_3 = 2
@12,12 say [Enter Word Length:    Use Up/Down arrows  ]+chr(24)+chr(25)
@12,31 prompt [7]
@12,31 prompt [8]
menu to menu_3
do  case
    case menu_3 = 1
        pword = 7
    case menu_3 = 2
    	pword = 8
endcase
help_code = [01]
menu_3 = 1
do boxer with 10,09,14,71,[ ],blue
set color to &yellow
@12,12 say [Select Desired Comm. Port   :      Use Up/Down arrows  ]+chr(24)+chr(25)]
@12,42 prompt [COM1]
@12,42 prompt [COM2]
menu to menu_3
do  case
    case menu_3 = 1
        port = 1 
	opencomm(port,2000,2000)
    case menu_3 = 2
        port = 2
	opencomm(port,2000,2000)
endcase
menu_3 = 1
@12,12 say space(58)
@12,12 say [Speed Dialing:       Use Up/Down arrows  ]+chr(24)+chr(25)
@12,28 prompt [ON ]
@12,28 prompt [OFF]
menu to menu_3
do  case
    case menu_3 = 1
    	smsetreg(port,[11],[50])
    case menu_3 = 2
    	smsetreg(port,[11],[70])
endcase
@12,12 say space(58)
tmpvar = [Y]
help_code = [02]
@12,20 say [Press <RETURN> To Continue... ] get tmpvar pict[!] valid(tmpvar$[YN])
read
if  pparity = 0
    hparity = [NONE]]
else
    if  pparity = 1
	hparity = [ODD]
    else
	if  pparity = 2
	    hparity = [EVEN]
	endif
    endif
endif
clk = [   MAIL: ^T  ]
head = [ Baud:]+str(baud,5,0)+[  ]+[Parity: ]+hparity+[  ]+[Stop Bits: ]+str(pstop,1,0)+[  ]+[Word Length: ]+str(pword,1,0)+[  ]+[Exit: ESC]+[ ]+clk
return


************************************************************
*	Emulation Tree, Branch to Correct Emulation        *
************************************************************
PROCEDURE term
do  case
    case emtype = [A]
    	do  aterm
    case emtype = [S]
    	do  sterm
    case emtype = [D]
    	do  dterm
    case emtype = [T]
    	do  tterm
endcase
if  auto
    smescape(port)
    smautoansw(port,[0])
    auto = .F.
endif
set color to &yellow
clear
RETURN


PROCEDURE tterm
set color to &yellow
clear
@1,0 say ddial
ddial = []
set color to &yellowt
@0,0 say head
@1,0 say []
swemtty(port,1,24,7,attrib)
RETURN


*****************************************************************
*	This procedure shows how to send a file via XMODEM.	*
*****************************************************************
PROCEDURE upload
setbaud(port,baud,pparity,pstop,pword)
do boxer with 10,04,14,75,[ ],blue
set color to &yellow
filchk = [?]
mfile = [?]
do  while (mfile != space(40))
    help_code = [04]
    set color to &yellow	 
    mfile = space(40)
    @12,12 say [Enter Filename: ] get mfile 
    read
    if  ! file(mfile)
    	if  mfile != space(40)
	    tmpvar = [?]
	    @12,12 say space(58)
	    set color to &red
	    @12,19 say [File Not Found press any key to continue: ] get tmpvar 
	    read
	    @12,19 say space(45)
	endif
    else
    	tfile = mfile
        mfile = space(40)
	filchk = [T]
    endif
enddo
if  filchk = [T] 
    blocks = str(txxblocks(tfile),8,0)
    bytes = str(swfilesize(tfile),8,0)
    time = timer(txxtime(tfile,baud))
    do  xmodbox	
    set color to &blink
    @03,44 say [  Transmitting: ]
    set color to &blue
    @14,74 say []
    start = seconds()
    error = errorchk(txxmodem(port,tfile))
    stop = seconds()
    time = stop - start
    time = timer(time)
    set color to &blink
    @08,60 say error
    set color to &yellow
    @03,44 say [      PROTOCOL: XMODEM]
    @09,44 say [   ACTUAL TIME: ]+time
    tmpvar = [?]
    help_code = [03]
    set color to &red
    @13,43 say [Press <ENTER> To Continue...] get tmpvar
    read
    do  term
endif
return


*************************************************************************
*	This procedure displays the XMODEM transfer information box.    *
*************************************************************************
PROCEDURE xmodbox
clear
do boxer with 02,40,14,79,[ ],blue
set color to &yellow
@03,44 say [      PROTOCOL: XMODEM]
@04,44 say [     FILE NAME: ]+trimfile(tfile)
@05,44 say [     FILE SIZE: ]+bytes
@06,44 say [BLOCKS IN FILE: ]+blocks
@07,44 say [ TRANSFER TIME: ]+time
@08,44 say [    LAST ERROR: ]
@13,44 say [Press Ctrl-X To Abort...]
return



************* FUNCTIONS *************

*************************************************************************
*	This function converts SilverComm numeric return codes into	*
*	a descriptive string.						*
*************************************************************************
FUNCTION errorchk
PARAMETER eret
error = [ ]
do  case
    case eret = 0 
	error = [cSUCCESSFUL]
    case eret = -99
	error = [cINVALIDPORT]
    case eret = -98
	error = [cPORTINUSE]
    case eret = -97
	error = [cBUFFERTOOLARGE]
    case eret = -96
	error = [cINSUFFICIENTMEMORY]
    case eret = -95
	error = [cDEVICEABSENT]
    case eret = -94
	error = [cNOTINITIALIZED]
    case eret = -93
	error = [cINVALIDPARAMETER]
    case eret = -92
	error = [cBUFFERISFULL]
    case eret = -91
	error = [cBUFFERISEMPTY]
    case eret = -90
	error = [cPARAMETERCOUNT]
    case eret = -89
	error = [cTIMEOUT]
    case eret = -88
	error = [cUSERABORT]
    case eret = -87
	error = [cDOSDISKERROR]
    case eret = -86
	error = [cNOCARRIER]
    case eret = -85
	error = [cLOSTCARRIER]
    case eret = -84
	error = [cNOINITIALNAK]
    case eret = -83
	error = [cNOREMOTERESPONSE]
    case eret = -82
	error = [cREMOTEUSERABORT]
    case eret = -81
	error = [cNOMORERETRIES]
    case eret = -80
	error = [cBLOCKFRAMEERROR]
    case eret = -79
	error = [cSHORTBLOCK]
    case eret = -78
	error = [cBLOCKSEQUENCEERROR]
    case eret = -77
	error = [cCHECKSUMERROR]
endcase
?chr(7)+chr(7)+chr(7)+chr(7)
RETURN error


*************************************************************************
*	This function returns the SilverComm version and revision.	*
*************************************************************************
FUNCTION setver
ver = swasyncver()
rev = swasyncrev()
if  rev < 10
    version = str(ver,2,0)+[.]+[0]+str(rev,1,0)
else
    version = str(ver,2,0)+[.]+str(rev,2,0)
endif
RETURN version


*****************************************************************************
*	This function converts seconds into "hour:minute:second" format.    *
*****************************************************************************
FUNCTION timer
PARAMETER time
hour = int(time/3600)
if  hour > 0
    time = time - (hour * 3600)
endif
min = int(time/60)
if  min > 0 
    time = time - (min * 60)
endif
sec = int(time)
if  hour <= 9
    chour = [0]+str(hour,1,0)
else
    chour = str(hour,2,0)
endif
if  min <= 9
    cmin = [0]+str(min,1,0)
else
    cmin = str(min,2,0)
endif
if  sec <= 9
    csec = [0]+str(sec,1,0)
else
    csec = str(sec,2,0)
endif
time = chour+[:]+cmin+[.]+csec
RETURN time


**************************************************************
*	This function trims the path off of a file name.     *
**************************************************************
FUNCTION trimfile
PARAMETER trfil
trfil = trim(trfil)
le = len(trfil)
done = .F.
i = 0
do  while ! done
    if  le = 0
    	done = .T.
    else
	chk = substr(trfil,le,1)
	if  chk = [\] .or. chk = [:]
    	    done = .T.
            trfil = substr(trfil,le + 1,i)
	else
    	    i = i + 1
    	    le = le - 1
	endif
    endif
enddo
RETURN trfil 


******************************************************************************
*	This function performs the auto redial loop for last dialed number  *
******************************************************************************
FUNCTION dialloop
key = 0
set color to &yellow
clear
key = inkey()
value = 0
chk = .F.
do  while (key != 27) .and. ! chk
    key = inkey()
    if  key = 27
    	smswhook(port,[0])
	rxflush(port)
	value = 0
    	exit
    endif
    smescape(port)
    rxflush(port)
    ddial = []
    @1,0 say [Redialing Last Number...]
    smdial(port,last)
    rxflush(port)
    sec = seconds()
    chk = .F.
    do  while seconds() < (sec + 20) .and. seconds() != 0 .and. key != 27 .and. ! chk
    	key = inkey()
    	chk = statuscd(port)
    enddo
    if  chk
    	value = 1
    endif
enddo
RETURN value